# -*- coding: utf-8 -*-
"""
Euler - S4
January 2019
"""

from algopy import graphmat


# graph is given as a pair(order, edge list)
# we assume graph does not has isolated vertex!

def graph_from_list(n, A):
    """
    A: edge list 
    n: graph order
    """
    G = graphmat.GraphMat(n, directed=False)
    for (i, j) in A:
        G.adj[i][j] += 1
        if i != j:
            G.adj[j][i] += 1
    return G


# check whether a graph (from a list of edges) is eulerian
# if so returns the list of odd vertices otherwise returns None

def __is_eulerian(G, s, M, L):
    """
    returns (nb met vertices, nb odd vertices)
    L: odd vertex list
    """
    (nb, odd) = (1, 0)
    M[s] = True
    d = G.adj[s][s]
    for i in range(G.order):
        if G.adj[s][i]:
            d += G.adj[s][i]
            if not M[i]:
                (n, o) = __is_eulerian(G, i, M, L)
                nb += n
                odd += o
                if odd > 2:
                    return (nb, odd)
            
    if d % 2 == 1:
        odd += 1   
        L.append(s)
    return (nb, odd)
    
def is_eulerian(G):
    M = [False] * G.order    
    L = []
    (nb, odd) = __is_eulerian(G, 0, M, L) 
    if (nb == G.order) and (odd < 3):
        return L
    else:
        return None
        

houseList = (8, 
             [(0,1), (0,2), (0,6),(1,2),(1,2),(2,7),(3,4),(3,4),(3,5),(3,6),
             (4,5),(4,7),(5,6),(5,7),(6,7)])
EulerHouse = graph_from_list(8, houseList[1])

housePaths = [
              [1, 0, 2, 1, 2, 7, 5, 6, 7, 4, 3, 4, 5, 3, 6, 0],
              [1, 2, 7, 6, 5, 7, 4, 3, 4, 5, 3, 6, 0, 2, 1, 0],
              [0, 6, 7, 5, 6, 3, 4, 3, 5, 4, 7, 2, 1, 2, 0, 1],
              [0, 1, 2, 0, 6, 5, 7, 6, 3, 4, 3, 5, 4, 7, 2, 1]]


        
# question 2: check whether a list is an eulerian path (graph is supposed to be eulerian)
def test_Euler_path(G, path):
    #FIXME
    pass



# BONUS: for an eulerian graph, find an eulerian path


def Eulerpath(A, n):
    #FIXME
    pass